//------------------------------------------------------------------------------
// <auto-generated />
//
// This file was automatically generated by SWIG (http://www.swig.org).
// Version 3.0.12
//
// Do not make changes to this file unless you know what you are doing--modify
// the SWIG interface file instead.
//------------------------------------------------------------------------------

namespace OpenMMNET {

public class VariableVerletIntegrator : Integrator {
  private global::System.Runtime.InteropServices.HandleRef swigCPtr;

  internal VariableVerletIntegrator(global::System.IntPtr cPtr, bool cMemoryOwn) : base(OpenMMSwigPINVOKE.VariableVerletIntegrator_SWIGUpcast(cPtr), cMemoryOwn) {
    swigCPtr = new global::System.Runtime.InteropServices.HandleRef(this, cPtr);
  }

  internal static global::System.Runtime.InteropServices.HandleRef getCPtr(VariableVerletIntegrator obj) {
    return (obj == null) ? new global::System.Runtime.InteropServices.HandleRef(null, global::System.IntPtr.Zero) : obj.swigCPtr;
  }

  ~VariableVerletIntegrator() {
    Dispose();
  }

  public override void Dispose() {
    lock(this) {
      if (swigCPtr.Handle != global::System.IntPtr.Zero) {
        if (swigCMemOwn) {
          swigCMemOwn = false;
          OpenMMSwigPINVOKE.delete_VariableVerletIntegrator(swigCPtr);
        }
        swigCPtr = new global::System.Runtime.InteropServices.HandleRef(null, global::System.IntPtr.Zero);
      }
      global::System.GC.SuppressFinalize(this);
      base.Dispose();
    }
  }

  public VariableVerletIntegrator(double errorTol) : this(OpenMMSwigPINVOKE.new_VariableVerletIntegrator(errorTol), true) {
  }

  public double getErrorTolerance() {
    double ret = OpenMMSwigPINVOKE.VariableVerletIntegrator_getErrorTolerance(swigCPtr);
    return ret;
  }

  public void setErrorTolerance(double tol) {
    OpenMMSwigPINVOKE.VariableVerletIntegrator_setErrorTolerance(swigCPtr, tol);
  }

  public override void step(int steps) {
    OpenMMSwigPINVOKE.VariableVerletIntegrator_step(swigCPtr, steps);
  }

  public void stepTo(double time) {
    OpenMMSwigPINVOKE.VariableVerletIntegrator_stepTo(swigCPtr, time);
  }

}

}
